using System;
using System.Collections.Generic;
using System.Text;

namespace TEAMModelOS.SDK.Models.Cosmos.Common
{

    /*
/vote/
/survey/
/exam/
/learn/
/homework/

{
    "id": "业务id",
    "code": "学校编码-学生id",
    "scode": "业务code",
    "type": "业务类型,  vote投票 survey问卷 exam评测 learn学习活动 homework作业活动 课程 ",
    "name": "业务名称",
    "startTime": 1616411700000,
    "endTime": 1616411700000,
    "scope": "school/private",
    "pk": "Activity",
    "school": "hbcn",
    "creatorId": "habook001",
    "subjects": [
        ""
    ],
    "classes":["class1 记录当前活动 选择包含这个学生的班级"]
    "blob": "业务详情blob详情位置",
    "recordUrl": "暂时不对其设计，隐藏规则调用，因为结算再次写入需要RU开销，学生参与业务的记录xxx/id/xxxx.json"
}

     */
    /// <summary>
    /// 学生集合的 学生活动相关列表。
    /// </summary>
    public class StuActivity : CosmosEntity
    {
        /// <summary>
        /// 源数据的发布层级 类型 school  teacher
        /// </summary>
        public string owner { get; set; }
        /// <summary>
        /// 源数据的 code
        /// </summary>
        public string scode { get; set; }
        public string type { get; set; }
        public string name { get; set; }
        public long startTime { get; set; }
        public long endTime { get; set; }
        public string scope { get; set; }
        public string school { get; set; }
        public string creatorId { get; set; }
        public List<string> subjects { get; set; }
        public string blob { get; set; }
        public string recordUrl { get; set; }
        public List<string> classIds { get; set; } = new List<string>();
        
        public long createTime { get; set; }= DateTimeOffset.UtcNow.ToUnixTimeMilliseconds();
        /// <summary>
        /// 任务完成状态，-1 未参与，0，未完成， 1已完成
        /// </summary>
        public int taskStatus { get; set; } = -1;
        //写入投票记录
    }
}
