using System;
using System.Collections.Generic;
using System.Text;
using System.Text.Json;

namespace TEAMModelOS.SDK.Models
{
    public class Study : CosmosEntity
    {
        //教研活动
        public Study()
        {
            pk = "Study";
        }

        public string name { get; set; }
        public string school { get; set; }
        //高级设置
        public List<string> settings { get; set; } = new List<string>();
        public string creatorId { get; set; }
        public long createTime { get; set; }
        public long updateTime { get; set; }
        public int hour { get; set; }
        //教研类型
        public int type { get; set; } = 0;
        /// <summary>
        ///  行政班  
        /// </summary>
        public List<string> classes { get; set; } = new List<string>();
        /// <summary>
        /// 学生名单（包含自定义个人学生名单，学校教学班）
        /// </summary>
        public List<string> stuLists { get; set; } = new List<string>();
        /// <summary>
        /// 教研组名单
        /// </summary>
        public List<string> tchLists { get; set; } = new List<string>();
        /// <summary>
        /// student 学生名单类型    research 教研组名单
        /// </summary>
        public string targetType { get; set; }
        /// <summary>
        /// 发布对象全部信息。由前端操作，用于前端回显发布对象的格式。
        /// </summary>
        public List<JsonElement> targets { get; set; } = new List<JsonElement>();
        public List<Setting> teachers { get; set; } = new List<Setting>();
        public string progress { get; set; }
        public string scope { get; set; }
        public int? status { get; set; } = 0;
        //记录该评测内容下blob大小
        public long? size { get; set; } = 0;
        /// <summary>
        ///发布层级 类型 school  area
        /// </summary>
        public string owner { get; set; }
        public string areaId { get; set; }
        public string pId { get; set; }
        public string presenter { get; set; }
        public string topic { get; set; }
        public long startTime { get; set; }
        public long endTime { get; set; }
        public string address { get; set; }
        //培训内容
        public string desc { get; set; }
        public string img { get; set; }
        public string workId { get; set; }
        public string surveyId { get; set; }
        public string examId { get; set; }
    }
    public class Setting
    {
        public string id { get; set; }
        public string name { get; set; }
        public string groupName { get; set; }
        public string sign { get; set; }
        public long signTime { get; set; }
/*        public string hw { get; set; }
        public long hwTime { get; set; }*/
        //0未审核 1 通过 2 未通过
        public int status { get; set; }
        public long aTime { get; set; }
    }
}
