using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Text;
using TEAMModelOS.SDK.Context.Attributes.Azure;
using TEAMModelOS.SDK.DI;
using TEAMModelOS.SDK.Models.Cosmos.Common;

namespace TEAMModelOS.SDK.Models
{
    /// <summary>
    /// Teaching materials 教学材料 ---课纲章节 数据结构
    /// </summary>

    public class Syllabus : CosmosEntity
    {  
        /// <summary>
        /// 册别编码
        /// </summary>
        [Required(ErrorMessage = "{0} 必须填写")]
        public List<Tnode> children { get; set; }
        public string volumeId { get; set; }
        public string codeval { get; set; }
        public List<SyllabusAuth> auth { get; set; } = new List<SyllabusAuth>();
        public string scope { get; set; }
}

    /// <summary>
    /// 只要创建课纲的creatorId 才能编辑课纲的分享，共编权限 25600 74200  27500 2000
    /// ,共编者 谁创建的节点只能谁删除，而且删除时能删除子节点(包含不是自己创建的)。
    /// </summary>
    public class SyllabusAuth
    {
        public string tmdid { get; set; }
        public string tmdname { get; set; }
        /// <summary>
        /// 分享  type=coedit共编,share分享
        /// </summary>
        public string type { get; set; }
        /// <summary>
        /// 是否同意
        /// </summary>
        public int agree { get; set; } = 0;
    }
     
}
