using System;
using System.Collections.Generic;
using System.Text;

namespace TEAMModelOS.SDK.Models
{
    /// <summary>
    /// 视频点评
    /// </summary>
    public class Appraise : CosmosEntity
    {
        //id  设计：课堂实录文件的id
        //code 分区键设计    Appraise-课堂实录的文件的所有者tmdid
        public List<AppraiseRole> roles { get; set; } = new List<AppraiseRole>();
    }

    public class AppraiseRole {
        //评审人的醍摩豆id
        public string commentTmdid { get; set; }
        /// <summary>
        /// 角色类型  成员 member 学校school  专家 expert
        /// </summary>
        public string roleType { get; set; }
        /// <summary>
        /// 点评维度
        /// </summary>
        public List<AppraiseDimension> dimensions { get; set; } = new List<AppraiseDimension>();
        /// <summary>
        /// 点评结果
        /// </summary>
        public int score { get; set; } = -1;
        /// <summary>
        /// 点评时间线
        /// </summary>
        public List<TimeLine> timeLines { get; set; } = new List<TimeLine>();
    }
    /// <summary>
    /// 教学实践
    /// </summary>
    public class AppraiseDimension
    {
        //教学效果，教学过程，教学设计，融合创新，技术应用
        public string id { get; set; }
        /// <summary>
        /// 维度
        /// </summary>
        public double star { get; set; }
    }
    public class TimeLine
    {
        /// <summary>
        /// 回复id
        /// </summary>
        public string replyId { get; set; }
        /// <summary>
        /// video time
        /// </summary>
        public long videoTime { get; set; }
        /// <summary>
        /// 评论标签
        /// </summary>
        public string tag { get; set; }
        /// <summary>
        /// 评论时间点在视频的进度是百分之多少
        /// </summary>

        public double per { get; set; }

    }
}
