using System;
using System.Collections.Generic;
using System.Text;

namespace TEAMModelOS.SDK.Models
{
    /// <summary>
    /// 用于表示学员的 课堂实录 放在Teacher表中
    /// </summary>
    public class ClassVideo : CosmosEntity
    {
        //id  设计：技能点的 abilityId
        //code 分区键设计    AbilitySub-hbcn-tmdid
        /// <summary>
        /// 学校编码
        /// </summary>
        public string school { get; set; }
        /// <summary>
        /// 创建者醍摩豆id
        /// </summary>
        public string creatorId { get; set; }
        public List<AbilityFile> files { get; set; } = new List<AbilityFile>();
    }

    public class AbilityFile {
        /// <summary>
        /// 作品总评
        /// </summary>
        public int score { get; set; } = -1;
        /// <summary>
        /// 课堂实录id 同时也是评论/话题的统一id（comid作用）,用于被关联
        /// </summary>
        public string id { get; set; }
        /// <summary>
        /// 地址
        /// </summary>
        public string url { get; set; }
        /// <summary>
        /// 文件名
        /// </summary>
        public string name { get; set; }
        /// <summary>
        /// 上传时间
        /// </summary>
        public long time { get; set; }
        /// <summary>
        /// 文件大小
        /// </summary>
        public long  size{ get; set; }
    }
   
}
