using Azure.Cosmos;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Text;
using System.Text.Json;
using System.Text.Json.Serialization;
using TEAMModelOS.SDK.Context.Attributes.Azure;
using TEAMModelOS.SDK.DI;

namespace TEAMModelOS.SDK.Models
{    
    /// <summary>
    /// 班级
    /// </summary>
    public class Class : CosmosEntity
    {
        public Class()
        {
            pk = "Class";
            teacher = new Teachers();
            //students = new List<StudentSimple>();
        }
        /// <summary>
        /// 班级编号
        /// </summary>
        public string no { get; set; }

       // public float? x { get; set; }
       // public float? y { get; set; }
       /// <summary>
       /// 班级名称
       /// </summary>
        public string name { get; set; }
        /// <summary>
        /// 教师
        /// </summary>
        public Teachers teacher { get; set; }
        /// <summary>
        /// 学段
        /// </summary>
        public string periodId { get; set; }
        /// <summary>
        /// 年级 此字段再入学年的情况下已经无用，现阶段只是用来处理历史数据
        /// </summary>
        public string gradeId { get; set; }
        //入学年
        public int year { get; set; }
        //public string sn { get; set; }
        /// <summary>
        /// TBL IRS 类型区分
        /// </summary>
        //public string style { get; set; }
        public int status { get; set; } = 1;        
        /// <summary>
        /// 关联教室的id
        /// </summary>
        public string room { get; set; }
        //学校编码
        public string school { get; set; }
        /// <summary>
        /// 教室属性，普通 /专设的教室
        /// </summary>
        //public string openType { get; set; }
       // public string scope { get; set; }
        /// <summary>
        /// 学生名单数据来源 1是不同学校的学生账号，2是扫码加入的醍摩豆ID
        /// </summary>
        //public int? source { get; set; }
        
    }
}
