using System;
using System.Collections.Generic;
using System.Text;


namespace TEAMModelOS.SDK.Models
{
    public class Period
    {
        public Period()
        {
            grades = new List<string>();
            subjects = new List<Subject>();
            semesters = new List<Semester>();
            analysis = new Analysis();
            majors = new List<Major>();
        }
        /// <summary>
        /// 高职教专业
        /// </summary>
        public List<Major> majors { get; set; }
        public List<string> grades { get; set; }
        public List<Subject> subjects { get; set; }
        public List<Semester> semesters { get; set; }
        public string name { get; set; }
        public string id { get; set; }
        public int gradeCount { get; set; }
        public int semesterCount { get; set; }
        public int subjectCount { get; set; }
        //保存校区编码
        public string campusId { get; set; }
        public Analysis analysis { get; set; }
        /// <summary>
        /// 课程计划表
        /// </summary>
        public List<TimeTable> timetable { get; set; } = new List<TimeTable>();
    }

    /// <summary>
    /// 高职教的专业
    /// </summary>
    public class Major
    {
        /// <summary>
        /// id
        /// </summary>
        public string id { get; set; }
        /// <summary>
        /// 名称
        /// </summary>
        public string name { get; set; }
    }

    public class Analysis
    {
        public List<ExamSimple> type { get; set; } = new List<ExamSimple>();
        public int income { get; set; }
        public int eugenics { get; set; }
        public int touch { get; set; }
    }
}
