export default {
	setting_title1: 'School Management',
	setting_title2: 'General Settings',
	setting_title3: 'Open Platform',
	schoolList: 'Schools that have joined or applied',
	langSetting: 'Website Language Settings',
	langTips: 'Please select the language in which the site will display menus, interactive pages and notifications',
	langCheck: 'Display using browser language',
	themeSetting: 'Website Color Mode',
	themeTips: 'Please select the color mode of the website display in order to provide the best user experience',
	menuSetting: 'Menu Display Settings',
	menuTips: 'Select the default display for the Menu on the left when the site is loaded',
	menuOpen: 'Display by default',
	menuClose: "Don't display by default",
	logoSetting: 'Logo Display Settings',
	logoTips: 'Choose whether to hide the platform logo in the upper left corner',
	logoOpen: 'Display by default',
	logoHide: "Don't display by default",
	defaultSchool: 'Default School',
	curSchool: 'Current School',
	courseNum: 'Course Number',
	activityNum: 'Activity Number',
	joinStatus: 'Request to join',
	requestStatus: 'Received the invitation to join',
	setDefault:'Set as default school',
	goSchool: 'Go to school',
	agreeJoin: 'Agree to join',
	cancelAdd: 'Decline to join',
	undoJoin: 'Withdraw request',
	requestJoin: 'Request to join',
	inputSearch: 'Enter the name of the school you want to search for',
	hasManager: 'The school has system administrator',
	hasBaseModule: 'Management Module',
	modalTip1: 'Notice',
	modalTip2: "This action will cause you to leave your current school's IES 5 and go to",
	modalTip3: 'Any unsaved information on this page will be lost, do you agree to continue?',
	modalTip7:'Confirm to set',
	modalTip8:'as your default school?',
	columnName: 'School Name',
	columnArea: 'Areal',
	columnId: 'School Short Code',
	columnTool: 'Operations',
	modalTip4: 'Friendly Reminder',
	modalTip5: 'Confirm joining ',
	modalTip6: 'Confirm cancellation of joining ',
	joinTip1:'Thank you for choosing your school',
	joinTip2:'After applying, your school name will be displayed the next time you log in!',
	joinTip3:'Note: The application must be reviewed by the administrator of the school you are applying to before you can officially access the resources provided by the school.',
	submitSucTips: 'Submitted successfully',
	submitFailTips: 'Failed to operate',
	joinSucTips: 'Join successfully!',
	status1: 'Joined',
	status2: 'Invitation Received',
	status3: 'Applying',
	searchTip: 'Please enter <span>school name</span> or <span>school code</span> to search',
	searchNone: '* If you do not find the school you are looking for, you can click below to request to create your school',
	searchPoper: 'If your school has a human icon, your application will be reviewed and approved by an administrator to become a member of the school. If your school does not have an administrator, your school and the "applying" status will be displayed after you apply and re-login.',
	applyBtn: 'Apply to create a school',
	openList: 'Open Platform List',
	openInfo: 'Platform Information',
	openName: '應用名稱',
    opName: "開放平台應用",
    token: 'ApiToken',
    des: '描述',
    openStatus: '狀態',
    enable: '啟用',
    disable: '禁用',
    webhook: "通知接口配寘",
    authorization: "接口金鑰",
    domainName: "域名",
	subNews: "訂閱通知接口",
	apiType1: "數據寫入接口",
	apiType2: "數據讀取接口",
    apiName: '接口名稱',
    apiAddress: '接口地址',
    apiMethod: '請求方法',
    apiParams: '參數示例',
    newName: "通知名稱",
    openKeep: '儲存平臺',
    edit: "編輯應用",
    unedit: '取消編輯',
    delModal1: '您確定刪除',
    delModal2: '嗎？',
    delModal3: '刪除成功',
    delModal4: '刪除失敗',
    delModal5: '已取消刪除',
    keepModal1: '儲存成功',
    keepModal2: '儲存失敗',
    refreshModal1: '更新成功',
    refreshModal2: '更新失敗',
    refreshModal3: '更新後，原有的金鑰會失效，您確定要更新嗎？',
    refreshModal4: '已取消更新',
	copyModal1: "Copy successfully",
	copyModal2: "Failed to copy",
	openModal1: '應用列表取得失敗',
    openModal2: 'api列表取得失敗',
	applyForm: {
		title: 'Apply to create an AI Smarter School',
		name: 'Full Name of School/Institution',
		id: 'School/Institution Short Code',
		orgCode:'School/Institution VAT number',
		period:'School/Institution School System',
		code: 'School/Institution ID',
		address: 'School/Institution Address',
		manager: 'Person in charge of School/Institution',
		cellphone: 'School/Institution Contact Information',
		content: 'Remark Information',
		place0: 'Please enter the full name (not the abbreviation)',
		place1: 'Please select the area where the school is located',
		place2: 'Please enter the full address',
		place3: 'Please enter phone number, email address and other contact information',
		place4: 'You can fill in your remark information',
		place5: 'Please enter the name of the person in charge',
		place6: 'Please select the area where the school is located',
		place7: 'Please enter the VAT number or other government-issued organization uniform No.',
		submit: 'Submit Application',
		submitSuc: 'Application has been successfully submitted！',
		errTip1: 'Please select the correct area!',
		errTip2: 'Please fill in the information completely!',
		rule1: 'School name cannot be empty',
		rule2: 'The information of person in charge cannot be empty',
		rule3: 'Contact information cannot be empty',
		rule4: 'Address cannot be empty',
		applyTip: '*After the application is submitted, it will be reviewed within 5 working days and the applicant will be notified.',
		p1:'Elementary/Primary school',
		p2:'Middle school',
		p3:'High school/Vocational High School',
		p4:'University/College',
		p5:'Corporate / Other'
	}
}
