using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Text;
using TEAMModelOS.SDK.Models;
using TEAMModelOS.SDK.Context.Attributes.Azure;
using TEAMModelOS.SDK.DI;

namespace TEAMModelOS.SDK.Models
{
    /// <summary>
    /// 试卷信息
    /// </summary>
    public class PaperDto
    {
        public string id { get; set; }

        public string name { get; set; }
        public string code { get; set; }
        public string scope { get; set; }
        public int multipleRule { get; set; }
        public List<Slides> slides { get; set; }
        public string periodId { get; set; }
        public List<string> points { get; set; } = new List<string>();
        public List<string> gradeIds { get; set; } = new List<string>();
        public string subjectId { get; set; }
        public string subjectName { get; set; }
        public double score { get; set; }             

    }
    public class Slides
    {
        public string url { get; set; }

        public string type { get; set; }
        public Scoring scoring { get; set; } = new Scoring();

    }
    public class Scoring
    {
        public double score { get; set; }
        public List<string> knowledge { get; set; } = new List<string>();
        public int? field { get; set; }
        public List<string> ans { get; set; } = new List<string>();
    }
}
